Get a specific proposal
curl --request GET \
--url https://grid.squads.xyz/api/grid/v1/accounts/{address}/proposals/{proposal_address} \
--header 'Authorization: Bearer <token>' \
--header 'x-grid-environment: <x-grid-environment>'import requests
url = "https://grid.squads.xyz/api/grid/v1/accounts/{address}/proposals/{proposal_address}"
headers = {
"x-grid-environment": "<x-grid-environment>",
"Authorization": "Bearer <token>"
}
response = requests.get(url, headers=headers)
print(response.text)const options = {
method: 'GET',
headers: {'x-grid-environment': '<x-grid-environment>', Authorization: 'Bearer <token>'}
};
fetch('https://grid.squads.xyz/api/grid/v1/accounts/{address}/proposals/{proposal_address}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"data": {
"approved": [
"<string>"
],
"cancelled": [
"<string>"
],
"consensusAccount": "<string>",
"consensusAccountType": "<string>",
"proposalAddress": "<string>",
"rejected": [
"<string>"
],
"status": "<string>",
"statusTimestamp": 123,
"blockTime": "2023-11-07T05:31:56Z",
"lastModifiedSignature": "<string>",
"mainAccountAddress": "<string>",
"settingsAddress": "<string>",
"transactionIndex": 123
},
"metadata": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z"
}
}Proposals
Get Proposal
Retrieve details for a specific proposal
GET
/
api
/
grid
/
v1
/
accounts
/
{address}
/
proposals
/
{proposal_address}
Get a specific proposal
Retrieves detailed information about a specific proposal, including current status, voting state, and metadata.
By default, status is client-facing. For proposals that are internally closed on-chain, the API infers terminal outcome when possible (
executed, cancelled, or rejected).
Use showOnChainStatus=true to return the raw on-chain status value (including closed).
The
{address} parameter is your smart account address, and {proposal_address} is the specific proposal’s on-chain address from Create Proposal or List Proposals.Ownership Verification
The API verifies that the proposal belongs to the specified smart account. Requesting a proposal with the wrong account address returns 403 Forbidden.Understanding Voting State
The response includesapproved, rejected, and cancelled arrays showing which signers have voted:
const proposal = await grid.getProposal(accountAddress, proposalAddress);
// Calculate remaining votes needed
const votesNeeded = account.threshold - proposal.approved.length;
// Check if specific signer has voted
const hasVoted = proposal.approved.includes(signerAddress) ||
proposal.rejected.includes(signerAddress);
Related Endpoints
Authorizations
Your Grid API key from the Grid Dashboard
Headers
Target Solana environment
Path Parameters
Smart account address
Proposal address
Query Parameters
Return raw on-chain proposal status value
Was this page helpful?